package com.example.testvaadin6;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import com.vaadin.Application;
import com.vaadin.terminal.gwt.server.HttpServletRequestListener;
import com.vaadin.terminal.gwt.server.WebApplicationContext;
import com.vaadin.ui.Label;
import com.vaadin.ui.Window;

/**
 * Main application class.
 */
public class Testvaadin6Application extends Application  implements HttpServletRequestListener{
 
	private static final long serialVersionUID = 1L;

	private HttpServletResponse response;
	private HttpServletRequest request;
	
	@Autowired
	WinterBean winterBean;
	
	@Autowired(required=true)
	private SpringBean springBean;
	
	
	@Autowired
	private ApplicationContext applicationContext;
	
    @Override
    public void init() {
    	
		ServletContext servletContext = ((WebApplicationContext) this.getContext()).getHttpSession().getServletContext();
		applicationContext = WebApplicationContextUtils.getRequiredWebApplicationContext(servletContext);
    	
		WinterBean winterBean2 = applicationContext.getBean(WinterBean.class);
		SpringBean springBean2 = applicationContext.getBean(SpringBean.class);
		
		
        Window mainWindow = new Window("Testvaadin6 Application");
        
        System.out.println(springBean);
        
		Label label = new Label(" WinterBean : " + winterBean.getAdi());		
		
        mainWindow.addComponent(label);
        setMainWindow(mainWindow);
    }

	public void onRequestStart(HttpServletRequest request,
			HttpServletResponse response) {
		
		this.response = response;
		this.request = request;
		
	}

	public void onRequestEnd(HttpServletRequest request,
			HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}
	
}

